# w4 word segmentation & word freq

#查找替換

#讀入data
load('demo.RData')

library(dplyr)

#變成tidy format
install.packages("tidytext")
library(tidytext)
td = d %>%
  unnest_tokens(word, content)

#看高頻詞
td1 = td%>%
  count(word, sort=T)
head(td1)
top_n(td1,20,n)
td1

#去除停頓詞
sw=read.table("stop-mac.txt", header = T,sep="\r",quote = "", stringsAsFactors = F)
sw

td2 = td %>%
  anti_join(sw,by="word")%>%
  count(word, sort=T)
top_n(td2,20,n)

#圖形表示
install.packages("ggplot2")
library(ggplot2)

#柱狀圖，用"黑體-繁 中黑"作圖
td2 %>%
  filter(n > 80000) %>%
  mutate(word = reorder(word, n)) %>%
  ggplot(aes(n,word)) +
  theme(text=element_text(family="Kaiti TC", size=12))+
  geom_col() +
  labs(y=NULL) 

#文字雲
install.packages("RColorBrewer")
library(RColorBrewer)
install.packages("wordcloud")
library(wordcloud)

td2 %>%
  with(wordcloud(word, n, max.words = 50,family="Kaiti TC"))

#jieba斷詞
install.packages("jiebaR")
library(jiebaR)

user=read.table("coviduser-mac.txt",sep="",quote = "", stringsAsFactors = F)
#抽樣處理
d1=sample_n(d,100)

#pc 要用coviduser-win.txt這個用戶字典
#如果讀取有問題請用套件readr

#segmentation
cc=worker(stop_word = "stop-mac.txt",user = "coviduser-mac.txt")
sd=segment(d$content,cc)
sd[1:100]

#freq
sd1=freq(sd)
sd2=arrange(sd1,desc(freq))
top_n(sd2,10,freq)

#tagging text
tt=worker("tag",stop_word = "stop-mac.txt",user = "coviduser-mac.txt")
ta=vector_tag(sd,tt)
ta[1:100]

#change into a dataframe
tags=as_tibble(attributes(ta))
word=as_tibble(sd)
wordtag=cbind(word, tags)

#find "nr"
nr=wordtag %>%
  filter(names=="nr") %>%
  count(value,sort=T)
head(nr)

nt=wordtag %>%
  filter(names=="nt") %>%
  count(value,sort=T)
head(nt)

ns=wordtag %>%
  filter(names=="ns") %>%
  count(value,sort=T)
head(ns)

#比較文集間用字的相似度
install.packages("tidyr")
library(tidyr)
table(td$media)
td3=td%>%
  count(media,word) %>%
  spread(media,n)

cor.test(td3$`LINE TODAY`,td3$自由時報)
cor.test(td3$yahoo新聞,td3$Match生活網)

#計算每個詞在不同文集詞頻比例的差異
#先把NA變成0
td3[is.na(td3)]=0

td4=td3%>%
  select(word,`LINE TODAY`,自由時報)%>%
  mutate(p1=`LINE TODAY`/sum(`LINE TODAY`))%>%
  mutate(p2=`自由時報`/sum(`自由時報`))%>%
  mutate(diff=p1-p2)%>%
  arrange(desc(diff))
head(td4)

head(arrange(td4,diff))

td4%>%
  filter(word=="中國")



