
##### Goal: Fetch Articles in a Search Result Page
# 1. For Loop
# 2. CSS Selector & String Operation: html_attr, str_detect
# 3. Save your data: data.frame to csv

rm(list=ls())
setwd('C:/Python/Project_crawling_tutorial/scripts')
library(tidyverse)
library(rvest)

url = 'https://search.ltn.com.tw/list?keyword=%E9%A6%99%E6%B8%AF'
res = read_html(url)
article_urls = res %>% 
  html_nodes('ul.list li') %>% 
  html_node('a') %>%
  html_attr("href")

df = data.frame('title'=character(), 'text'=character(), 'time'=character(), 'url'=character())
for(a_url in article_urls){
  print(a_url)
  a_res = read_html(a_url)
  title = a_res %>%
    html_node('h1') %>%
    html_text()
  time = a_res %>%
    html_node('span.time') %>%
    html_text() %>%
    str_replace('\n','') %>%
    trimws()
  text = a_res %>%
    html_nodes('div[data-desc="內容頁"] p:not([class])') %>% 
    html_text() %>%
    paste(collapse="")
  article = data.frame('title'=title, 'text'=text, 'time'=time, 'url'=a_url)
  df = rbind(df, article)
}
write_excel_csv(df, file="../LTNResults.csv", ) # write_csv / write.csv (fileEncoding='UTF-8')
  