
##### Goal: Fetch Articles in a Search Result Page
# 1. CSS Selector & String Operation: html_attr, str_detect
# 2. For Loop

rm(list=ls())
library(tidyverse)
library(rvest)

url = 'https://search.ltn.com.tw/list?keyword=%E9%A6%99%E6%B8%AF'
res = read_html(url)
article_urls = res %>% 
  html_nodes('ul[data-desc="列表"] li') %>%
  html_node('a') %>%
  html_attr('href')

for(a_url in article_urls){
  print(a_url)
  if(str_detect(a_url, 'https://news.ltn.com.tw/')){
    res = read_html(a_url)
    title = res %>%
      html_node('h1') %>%
      html_text()
    time = res %>%
      html_node('span.time') %>%
      html_text() %>%
      str_replace('\n','') %>%
      trimws()
    text = res %>%
      html_nodes('div[data-desc="內容頁"] p:not([class])') %>%
      html_text() %>%
      paste(collapse="")
    print(title)
    print(time)
    print(text)
    readline()
  }
}

