
##### Goal: Fetch Articles in Multiple Search Result Pages
# 1. Functionized Code

rm(list=ls())
library(tidyverse)
library(rvest)

fetch_article = function(a_url) { 
  print(a_url)
  tryCatch({
    article_res = read_html(a_url)
    title = article_res %>%
      html_node('h1') %>%
      html_text()
    text = article_res %>%
      html_nodes('div[data-desc="內容頁"] p:not([class])') %>% 
      html_text() %>%
      paste(collapse="")
    time = article_res %>%
      html_node('span.time') %>%
      html_text() %>%
      str_replace('\n','') %>%
      trimws()
  },
  error = function(e){print(paste0('Error in url: ', a_url))}
  )
  Sys.sleep(runif(1,0.5,1))
  return(data.frame('title'=title, 'text'=text, 'time'=time, 'url'=a_url))
} 

url = 'https://search.ltn.com.tw/list?keyword=%E9%A6%99%E6%B8%AF'
res = read_html(url)
article_urls = res %>% 
  html_nodes('ul[data-desc="列表"] li > a') %>%
  html_attr("href")

df = data.frame('title'=character(), 'text'=character(), 'time'=character(), 'url'=character())
for(a_url in article_urls){
  article = fetch_article(a_url)
  df = rbind(df, article)
}
write_excel_csv(result, file="../LTNResults.csv", ) # write_csv / write.csv (fileEncoding='UTF-8')
  