
##### Goal: Fetch Articles in Multiple Search Result Pages
# 1. While Loop: run through all pages, terminal condition

rm(list=ls())
library(tidyverse)
library(rvest)

fetch_article = function(a_url) { 
  print(a_url)
  tryCatch({
    article_res = read_html(a_url)
    title = article_res %>%
      html_node('h1') %>%
      html_text()
    text = article_res %>%
      html_nodes('div[data-desc="內容頁"] p:not([class])') %>% 
      html_text() %>%
      paste(collapse="")
    time = article_res %>%
      html_node('span.time') %>%
      html_text() %>%
      str_replace('\n','') %>%
      trimws()
  },
  error = function(e){print(paste0('Error in url: ', a_url))}
  )
  Sys.sleep(runif(1,0.5,1))
  return(data.frame('title'=title, 'text'=text, 'time'=time, 'url'=a_url))
} 

url_start = 'https://search.ltn.com.tw/list?keyword=%E9%A1%8F%E5%AF%AC%E6%81%86%20%E5%8F%B0%E4%B8%AD&type=all&sort=date&start_time=20190609&end_time=20200701'
df = data.frame('title'=character(), 'text'=character(), 'time'=character(), 'url'=character())

page = 1
res = read_html(url_start)

while(length(res %>% html_nodes('.noresults'))==0){
  print(paste0('page: ', as.character(page)))
  article_urls = res %>% 
    html_nodes('ul[data-desc="列表"] li > a') %>%
    html_attr("href")
  for(a_url in article_urls){
    article = fetch_article(a_url)
    df = rbind(df, article)
  }
  page = page + 1
  url = paste0(url_start, '&page=', as.character(page))
  res = read_html(url)
}
write_excel_csv(result, file="../LTNResults.csv", ) # write_csv / write.csv (fileEncoding='UTF-8')
  


https://search.ltn.com.tw/list?keyword=空污&type=all&sort=date&start_time=20230523&end_time=20230823
https://search.ltn.com.tw/list?keyword=空污&start_time=20230523&end_time=20230823&sort=date&type=all&page=1
https://search.ltn.com.tw/list?keyword=空污&start_time=20230523&end_time=20230823&sort=date&type=all&page=2
https://search.ltn.com.tw/list?keyword=空污&start_time=20230523&end_time=20230823&sort=date&type=all&page=3