#week2 practise dplyr & irr

load("demo.Rdata")

##安裝套件
install.packages("dplyr")

#啟動套件
library(dplyr)

#排序（order rows）
d1=sort(d$talklength)
d2=arrange(d,talklength)
d2=arrange(d,desc(talklength))

##選擇資料

#選擇變項
d1=select(d,content)
d1=select(d,title:date)
d1=select(d,-title)
d1=select(d, -(title:date))

#選擇觀察值
d1=d[1:10,]
#最大的100個值
d3=top_n(d, 100, talklength)

#過濾
d1=filter(d,media=="yahoo新聞")
d1=filter(d,negative>=50)	

#設定條件
d1=subset(d, talklength>10 & sentiment=="中立")
		
#刪除變項
d2$title=NULL
	
#刪除obs
d1=d[-c(1:3),]
	
##修改變項
#改變名稱
d=rename(d, source=media)   

#改變類型
d$source=as.factor(d$source)

##重新編碼,& 存成新變項
table(d$source)
d=mutate(d, media=recode(source,"LINE TODAY"="web media","TVBS新聞"="traditional media", "yahoo新聞"="web media", "Match生活網"="web media","Taiwan News Agency"="traditional media","自由時報"="traditional media") )
table(d$media)

#產生一個新變項size，計算每篇文章的字數
d$size=nchar(d$content)

#刪除太短的貼文
d1 =filter(d,size>=150) 

##選擇一個隨機的樣本：
#完全隨機挑100篇
d1=sample_n(d,500)

#每5篇挑一篇
d2= filter(d,row_number() %% 5 == 1)

write.csv(d1,file="intercoder500.csv")

#calculate intercoder reliability
#read in coders' coding data
install.packages("readxl")
library("readxl")
d1=read_excel("intercoder100.xlsx", sheet = 1)

install.packages("irr")
library(lpSolve)
library(irr)

#make a new dataframe for each variable
dc=select(d1,2:3)

#% of agreement
agree(dc)

#Cohen’s Kappa: nominal or an ordinal variable
kappa2(dc)

#Fleiss Kappa: n raters on categorical data
da=select(d1,4:6)
kappam.fleiss(da)

#ICC for continuous or ordinal variable
icc(dc)

#Krippendorff's alpha, 各種變數，特別適合較高級別
kripp.alpha(da)

da=as.matrix(da)

